From 74087a26ed15334ebe7da767fdf10a0d3d993175 Mon Sep 17 00:00:00 2001
From: Alvaro Herrera <alvherre@alvh.no-ip.org>
Date: Thu, 20 Jan 2022 17:51:37 -0300
Subject: [PATCH v8] MERGE SQL Command following SQL:2016
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

MERGE performs actions that modify rows in the target table using a
source table or query. MERGE provides a single SQL statement that can
conditionally INSERT/UPDATE/DELETE rows -- a task that would otherwise
require multiple PL statements.  For example,

MERGE INTO target AS t
USING source AS s
ON t.tid = s.sid
WHEN MATCHED AND t.balance > s.delta THEN
  UPDATE SET balance = t.balance - s.delta
WHEN MATCHED THEN
  DELETE
WHEN NOT MATCHED AND s.delta > 0 THEN
  INSERT VALUES (s.sid, s.delta)
WHEN NOT MATCHED THEN
  DO NOTHING;

MERGE works with regular and partitioned tables, including column and
row security enforcement, as well as support for row, statement and
transition triggers.

MERGE is optimized for OLTP and is parameterizable, though also useful
for large scale ETL/ELT. MERGE is not intended to be used in preference
to existing single SQL commands for INSERT, UPDATE or DELETE since there
is some overhead.  MERGE can be used statically from PL/pgSQL.

MERGE does not yet support inheritance, write rules, RETURNING clauses,
updatable views or foreign tables.  MERGE follows SQL Standard per the
most recent SQL:2016.

Includes full tests and documentation, including full isolation tests to
demonstrate the concurrent behavior.

Author: Simon Riggs <simon.riggs@enterprisedb.com>
Author: Pavan Deolasee <pavan.deolasee@gmail.com>
Author: Álvaro Herrera <alvherre@alvh.no-ip.org>
Author: Amit Langote <amitlangote09@gmail.com>
Author: Japin Li <japinli@hotmail.com>

Discussion: https://postgr.es/m/CANP8+jKitBSrB7oTgT9CY2i1ObfOt36z0XMraQc+Xrz8QB0nXA@mail.gmail.com
Discussion: https://postgr.es/m/CAH2-WzkJdBuxj9PO=2QaO9-3h3xGbQPZ34kJH=HukRekwM-GZg@mail.gmail.com
Discussion: https://postgr.es/m/20201231134736.GA25392@alvherre.pgsql
---
 contrib/test_decoding/expected/ddl.out        |   46 +
 contrib/test_decoding/sql/ddl.sql             |   16 +
 doc/src/sgml/libpq.sgml                       |    8 +-
 doc/src/sgml/mvcc.sgml                        |   34 +-
 doc/src/sgml/plpgsql.sgml                     |    3 +-
 doc/src/sgml/ref/allfiles.sgml                |    1 +
 doc/src/sgml/ref/create_policy.sgml           |   23 +-
 doc/src/sgml/ref/insert.sgml                  |   11 +-
 doc/src/sgml/ref/merge.sgml                   |  633 ++++++
 doc/src/sgml/reference.sgml                   |    1 +
 doc/src/sgml/trigger.sgml                     |   22 +
 src/backend/access/heap/heapam.c              |   30 +-
 src/backend/access/heap/heapam_handler.c      |    3 +-
 src/backend/catalog/sql_features.txt          |    6 +-
 src/backend/commands/explain.c                |   35 +
 src/backend/commands/prepare.c                |    1 +
 src/backend/commands/trigger.c                |  288 ++-
 src/backend/executor/Makefile                 |    1 +
 src/backend/executor/README                   |   13 +
 src/backend/executor/execMain.c               |   17 +
 src/backend/executor/execMerge.c              |  731 +++++++
 src/backend/executor/execPartition.c          |  113 +-
 src/backend/executor/execReplication.c        |    4 +-
 src/backend/executor/nodeModifyTable.c        |  244 ++-
 src/backend/executor/spi.c                    |    3 +
 src/backend/nodes/copyfuncs.c                 |   56 +
 src/backend/nodes/equalfuncs.c                |   49 +
 src/backend/nodes/nodeFuncs.c                 |   61 +-
 src/backend/nodes/outfuncs.c                  |   34 +
 src/backend/nodes/readfuncs.c                 |   41 +
 src/backend/optimizer/plan/createplan.c       |   15 +-
 src/backend/optimizer/plan/planner.c          |   59 +-
 src/backend/optimizer/plan/setrefs.c          |   64 +-
 src/backend/optimizer/prep/prepjointree.c     |   11 +
 src/backend/optimizer/prep/preptlist.c        |   39 +
 src/backend/optimizer/util/appendinfo.c       |   29 +-
 src/backend/optimizer/util/pathnode.c         |   11 +-
 src/backend/optimizer/util/plancat.c          |    4 +
 src/backend/parser/Makefile                   |    1 +
 src/backend/parser/analyze.c                  |   20 +-
 src/backend/parser/gram.y                     |  165 +-
 src/backend/parser/parse_agg.c                |   10 +
 src/backend/parser/parse_clause.c             |   67 +-
 src/backend/parser/parse_collate.c            |    1 +
 src/backend/parser/parse_expr.c               |    4 +
 src/backend/parser/parse_func.c               |    3 +
 src/backend/parser/parse_merge.c              |  535 ++++++
 src/backend/parser/parse_relation.c           |   46 +-
 src/backend/parser/parse_target.c             |    3 +-
 src/backend/rewrite/rewriteHandler.c          |   41 +-
 src/backend/rewrite/rowsecurity.c             |  106 +-
 src/backend/tcop/pquery.c                     |    3 +
 src/backend/tcop/utility.c                    |   16 +
 src/backend/utils/adt/ruleutils.c             |    9 +-
 src/bin/psql/tab-complete.c                   |   82 +-
 src/include/access/heapam.h                   |    2 +-
 src/include/access/tableam.h                  |    8 +
 src/include/commands/trigger.h                |    7 +-
 src/include/executor/execMerge.h              |   32 +
 src/include/executor/instrument.h             |    7 +-
 src/include/executor/nodeModifyTable.h        |   31 +
 src/include/executor/spi.h                    |    1 +
 src/include/nodes/execnodes.h                 |   31 +-
 src/include/nodes/nodes.h                     |    7 +-
 src/include/nodes/parsenodes.h                |   53 +-
 src/include/nodes/pathnodes.h                 |    6 +-
 src/include/nodes/plannodes.h                 |    7 +-
 src/include/optimizer/pathnode.h              |    2 +-
 src/include/parser/analyze.h                  |    5 +
 src/include/parser/kwlist.h                   |    2 +
 src/include/parser/parse_clause.h             |    5 +-
 src/include/parser/parse_merge.h              |   21 +
 src/include/parser/parse_node.h               |    5 +-
 src/include/parser/parse_relation.h           |    5 +-
 src/include/tcop/cmdtaglist.h                 |    1 +
 src/interfaces/libpq/fe-exec.c                |    9 +-
 src/pl/plpgsql/src/pl_exec.c                  |    7 +-
 src/pl/plpgsql/src/pl_gram.y                  |    8 +
 src/pl/plpgsql/src/pl_unreserved_kwlist.h     |    1 +
 src/pl/plpgsql/src/plpgsql.h                  |    2 +-
 src/test/isolation/expected/merge-delete.out  |  117 ++
 .../expected/merge-insert-update.out          |   94 +
 .../expected/merge-match-recheck.out          |  116 ++
 src/test/isolation/expected/merge-update.out  |  314 +++
 src/test/isolation/isolation_schedule         |    4 +
 src/test/isolation/specs/merge-delete.spec    |   50 +
 .../isolation/specs/merge-insert-update.spec  |   51 +
 .../isolation/specs/merge-match-recheck.spec  |   77 +
 src/test/isolation/specs/merge-update.spec    |  156 ++
 src/test/regress/expected/identity.out        |   54 +
 src/test/regress/expected/merge.out           | 1702 +++++++++++++++++
 src/test/regress/expected/privileges.out      |   98 +
 src/test/regress/expected/rowsecurity.out     |  182 ++
 src/test/regress/expected/rules.out           |   31 +
 src/test/regress/expected/triggers.out        |   48 +
 src/test/regress/expected/with.out            |  133 ++
 src/test/regress/parallel_schedule            |    2 +-
 src/test/regress/sql/identity.sql             |   46 +
 src/test/regress/sql/merge.sql                | 1184 ++++++++++++
 src/test/regress/sql/privileges.sql           |  108 ++
 src/test/regress/sql/rowsecurity.sql          |  156 ++
 src/test/regress/sql/rules.sql                |   33 +
 src/test/regress/sql/triggers.sql             |   47 +
 src/test/regress/sql/with.sql                 |   56 +
 src/tools/pgindent/typedefs.list              |    4 +
 105 files changed, 8749 insertions(+), 251 deletions(-)
 create mode 100644 doc/src/sgml/ref/merge.sgml
 create mode 100644 src/backend/executor/execMerge.c
 create mode 100644 src/backend/parser/parse_merge.c
 create mode 100644 src/include/executor/execMerge.h
 create mode 100644 src/include/parser/parse_merge.h
 create mode 100644 src/test/isolation/expected/merge-delete.out
 create mode 100644 src/test/isolation/expected/merge-insert-update.out
 create mode 100644 src/test/isolation/expected/merge-match-recheck.out
 create mode 100644 src/test/isolation/expected/merge-update.out
 create mode 100644 src/test/isolation/specs/merge-delete.spec
 create mode 100644 src/test/isolation/specs/merge-insert-update.spec
 create mode 100644 src/test/isolation/specs/merge-match-recheck.spec
 create mode 100644 src/test/isolation/specs/merge-update.spec
 create mode 100644 src/test/regress/expected/merge.out
 create mode 100644 src/test/regress/sql/merge.sql

diff --git a/contrib/test_decoding/sql/ddl.sql b/contrib/test_decoding/sql/ddl.sql
index 1b3866d015..4f76bed72c 100644
--- a/contrib/test_decoding/sql/ddl.sql
+++ b/contrib/test_decoding/sql/ddl.sql
@@ -93,6 +93,22 @@ COMMIT;
 /* display results */
 SELECT data FROM pg_logical_slot_get_changes('regression_slot', NULL, NULL, 'include-xids', '0', 'skip-empty-xacts', '1');
 
+-- MERGE support
+BEGIN;
+MERGE INTO replication_example t
+	USING (SELECT i as id, i as data, i as num FROM generate_series(-20, 5) i) s
+	ON t.id = s.id
+	WHEN MATCHED AND t.id < 0 THEN
+		UPDATE SET somenum = somenum + 1
+	WHEN MATCHED AND t.id >= 0 THEN
+		DELETE
+	WHEN NOT MATCHED THEN
+		INSERT VALUES (s.*);
+COMMIT;
+
+/* display results */
+SELECT data FROM pg_logical_slot_get_changes('regression_slot', NULL, NULL, 'include-xids', '0', 'skip-empty-xacts', '1');
+
 CREATE TABLE tr_unique(id2 serial unique NOT NULL, data int);
 INSERT INTO tr_unique(data) VALUES(10);
 ALTER TABLE tr_unique RENAME TO tr_pkey;
diff --git a/doc/src/sgml/libpq.sgml b/doc/src/sgml/libpq.sgml
index e0ab7cd555..e46df65a18 100644
--- a/doc/src/sgml/libpq.sgml
+++ b/doc/src/sgml/libpq.sgml
@@ -4125,9 +4125,11 @@ char *PQcmdTuples(PGresult *res);
        <structname>PGresult</structname>. This function can only be used following
        the execution of a <command>SELECT</command>, <command>CREATE TABLE AS</command>,
        <command>INSERT</command>, <command>UPDATE</command>, <command>DELETE</command>,
-       <command>MOVE</command>, <command>FETCH</command>, or <command>COPY</command> statement,
-       or an <command>EXECUTE</command> of a prepared query that contains an
-       <command>INSERT</command>, <command>UPDATE</command>, or <command>DELETE</command> statement.
+       <command>MERGE</command>, <command>MOVE</command>, <command>FETCH</command>,
+       or <command>COPY</command> statement, or an <command>EXECUTE</command> of a
+       prepared query that contains an <command>INSERT</command>,
+       <command>UPDATE</command>, <command>DELETE</command>
+       or <command>MERGE</command> statement.
        If the command that generated the <structname>PGresult</structname> was anything
        else, <xref linkend="libpq-PQcmdTuples"/> returns an empty string. The caller
        should not free the return value directly. It will be freed when
diff --git a/doc/src/sgml/mvcc.sgml b/doc/src/sgml/mvcc.sgml
index 6c94f6a942..72ec50675e 100644
--- a/doc/src/sgml/mvcc.sgml
+++ b/doc/src/sgml/mvcc.sgml
@@ -422,6 +422,37 @@ COMMIT;
     <literal>11</literal>, which no longer matches the criteria.
    </para>
 
+   <para>
+    <command>MERGE</command> allows the user to specify various
+    combinations of <command>INSERT</command>, <command>UPDATE</command>
+    or <command>DELETE</command> subcommands. A <command>MERGE</command>
+    command with both <command>INSERT</command> and <command>UPDATE</command>
+    subcommands looks similar to <command>INSERT</command> with an
+    <literal>ON CONFLICT DO UPDATE</literal> clause but does not
+    guarantee that either <command>INSERT</command> or
+    <command>UPDATE</command> will occur.
+    If MERGE attempts an <command>UPDATE</command> or
+    <command>DELETE</command> and the row is concurrently updated but
+    the join condition still passes for the current target and the
+    current source tuple, then <command>MERGE</command> will behave
+    the same as the <command>UPDATE</command> or
+    <command>DELETE</command> commands and perform its action on the
+    updated version of the row.  However, because <command>MERGE</command>
+    can specify several actions and they can be conditional, the
+    conditions for each action are re-evaluated on the updated version of
+    the row, starting from the first action, even if the action that had
+    originally matched appears later in the list of actions.
+    On the other hand, if the row is concurrently updated or deleted so
+    that the join condition fails, then <command>MERGE</command> will
+    evaluate the condition's <literal>NOT MATCHED</literal> actions next,
+    and execute the first one that succeeds.
+    If <command>MERGE</command> attempts an <command>INSERT</command>
+    and a unique index is present and a duplicate row is concurrently
+    inserted, then a uniqueness violation is raised.
+    <command>MERGE</command> does not attempt to avoid the
+    <literal>ERROR</literal> by executing an <command>UPDATE</command>.
+   </para>
+
    <para>
     Because Read Committed mode starts each command with a new snapshot
     that includes all transactions committed up to that instant,
@@ -924,7 +955,8 @@ ERROR:  could not serialize access due to read/write dependencies among transact
 
         <para>
          The commands <command>UPDATE</command>,
-         <command>DELETE</command>, and <command>INSERT</command>
+         <command>DELETE</command>, <command>INSERT</command> and
+         <command>MERGE</command>
          acquire this lock mode on the target table (in addition to
          <literal>ACCESS SHARE</literal> locks on any other referenced
          tables).  In general, this lock mode will be acquired by any
diff --git a/doc/src/sgml/plpgsql.sgml b/doc/src/sgml/plpgsql.sgml
index e5c1356d8c..4e83962cfd 100644
--- a/doc/src/sgml/plpgsql.sgml
+++ b/doc/src/sgml/plpgsql.sgml
@@ -1388,7 +1388,7 @@ EXECUTE format('SELECT count(*) FROM %I '
      Another restriction on parameter symbols is that they only work in
      optimizable SQL commands
      (<command>SELECT</command>, <command>INSERT</command>, <command>UPDATE</command>,
-     <command>DELETE</command>, and certain commands containing one of these).
+     <command>DELETE</command>, <command>MERGE</command>, and certain commands containing one of these).
      In other statement
      types (generically called utility statements), you must insert
      values textually even if they are just data values.
@@ -1667,6 +1667,7 @@ GET DIAGNOSTICS integer_var = ROW_COUNT;
           <listitem>
            <para>
             <command>UPDATE</command>, <command>INSERT</command>, and <command>DELETE</command>
+            and <command>MERGE</command>
             statements set <literal>FOUND</literal> true if at least one
             row is affected, false if no row is affected.
            </para>
diff --git a/doc/src/sgml/ref/allfiles.sgml b/doc/src/sgml/ref/allfiles.sgml
index d67270ccc3..7239b40281 100644
--- a/doc/src/sgml/ref/allfiles.sgml
+++ b/doc/src/sgml/ref/allfiles.sgml
@@ -159,6 +159,7 @@ Complete list of usable sgml source files in this directory.
 <!ENTITY load               SYSTEM "load.sgml">
 <!ENTITY lock               SYSTEM "lock.sgml">
 <!ENTITY move               SYSTEM "move.sgml">
+<!ENTITY merge              SYSTEM "merge.sgml">
 <!ENTITY notify             SYSTEM "notify.sgml">
 <!ENTITY prepare            SYSTEM "prepare.sgml">
 <!ENTITY prepareTransaction SYSTEM "prepare_transaction.sgml">
diff --git a/doc/src/sgml/ref/create_policy.sgml b/doc/src/sgml/ref/create_policy.sgml
index 9f532068e6..f45882814d 100644
--- a/doc/src/sgml/ref/create_policy.sgml
+++ b/doc/src/sgml/ref/create_policy.sgml
@@ -55,7 +55,8 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
   </para>
 
   <para>
-   For <command>INSERT</command> and <command>UPDATE</command> statements,
+   For <command>INSERT</command>, <command>UPDATE</command>, and
+   <command>MERGE</command> statements,
    <literal>WITH CHECK</literal> expressions are enforced after
    <literal>BEFORE</literal> triggers are fired, and before any actual data
    modifications are made.  Thus a <literal>BEFORE ROW</literal> trigger may
@@ -281,7 +282,9 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
       <listitem>
        <para>
          Using <literal>INSERT</literal> for a policy means that it will apply
-         to <literal>INSERT</literal> commands.  Rows being inserted that do
+         to <literal>INSERT</literal> commands and <literal>MERGE</literal>
+         commands that contain <literal>INSERT</literal> actions.
+         Rows being inserted that do
          not pass this policy will result in a policy violation error, and the
          entire <literal>INSERT</literal> command will be aborted.
          An <literal>INSERT</literal> policy cannot have
@@ -305,7 +308,9 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
          to <literal>UPDATE</literal>, <literal>SELECT FOR UPDATE</literal>
          and <literal>SELECT FOR SHARE</literal> commands, as well as
          auxiliary <literal>ON CONFLICT DO UPDATE</literal> clauses of
-         <literal>INSERT</literal> commands.  Since <literal>UPDATE</literal>
+         <literal>INSERT</literal> commands.
+         <literal>MERGE</literal> commands containing <literal>UPDATE</literal>
+         actions are affected as well.  Since <literal>UPDATE</literal>
          involves pulling an existing record and replacing it with a new
          modified record, <literal>UPDATE</literal>
          policies accept both a <literal>USING</literal> expression and
@@ -435,7 +440,7 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
        <entry>&mdash;</entry>
       </row>
       <row>
-       <entry><command>INSERT</command></entry>
+       <entry><command>INSERT</command> / <command>MERGE ... THEN INSERT</command></entry>
        <entry>&mdash;</entry>
        <entry>New row</entry>
        <entry>&mdash;</entry>
@@ -459,7 +464,7 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
        <entry>&mdash;</entry>
       </row>
       <row>
-       <entry><command>UPDATE</command></entry>
+       <entry><command>UPDATE</command> / <command>MERGE ... THEN UPDATE</command></entry>
        <entry>
         Existing &amp; new rows <footnoteref linkend="rls-select-priv"/>
        </entry>
@@ -611,6 +616,14 @@ AND
    owner's rights and any policies which apply to the view owner.
   </para>
 
+  <para>
+   No separate policy exists for <command>MERGE</command>. Instead, the policies
+   defined for <command>SELECT</command>, <command>INSERT</command>,
+   <command>UPDATE</command> and <command>DELETE</command> are applied
+   while executing <command>MERGE</command>, depending on the actions that are
+   performed.
+  </para>
+
   <para>
    Additional discussion and practical examples can be found
    in <xref linkend="ddl-rowsecurity"/>.
diff --git a/doc/src/sgml/ref/insert.sgml b/doc/src/sgml/ref/insert.sgml
index 2973b72b81..ad61d757af 100644
--- a/doc/src/sgml/ref/insert.sgml
+++ b/doc/src/sgml/ref/insert.sgml
@@ -589,6 +589,13 @@ INSERT <replaceable>oid</replaceable> <replaceable class="parameter">count</repl
    is a partition, an error will occur if one of the input rows violates
    the partition constraint.
   </para>
+
+  <para>
+   You may also wish to consider using <command>MERGE</command>, since that
+   allows mixing <command>INSERT</command>, <command>UPDATE</command> and
+   <command>DELETE</command> within a single statement.
+   See <xref linkend="sql-merge"/>.
+  </para>
  </refsect1>
 
  <refsect1>
@@ -759,7 +766,9 @@ INSERT INTO distributors (did, dname) VALUES (10, 'Conrad International')
    Also, the case in
    which a column name list is omitted, but not all the columns are
    filled from the <literal>VALUES</literal> clause or <replaceable>query</replaceable>,
-   is disallowed by the standard.
+   is disallowed by the standard. If you prefer a more SQL Standard
+   conforming statement than <literal>ON CONFLICT</literal>, see
+   <xref linkend="sql-merge"/>.
   </para>
 
   <para>
